
{$APPTYPE GUI}{$MODE DELPHI}

program demo3;

uses
  SysUtils,windows,math,gl,glu,glext,GraphOGL,GraphOGL_Ext1;

//const
 
//type
  
//var 
   
//{$R *.rc}
//{$R *.res}  
 
 
procedure Quad(x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4:glFloat);
begin
  TwoSideON;
  glDisable(GL_CULL_FACE);
  glBegin(GL_QUADS);
   FindNormal(x2,y2,z2,x1,y1,z1,x3,y3,z3);
   glNormal3f(FNormal[1], FNormal[2], FNormal[3]);
	LineFree(3,3, 0,3, x2,y2,z2, x1,y1,z1,true);
	LineFree(0,0, 3,0, x3,y3,z3, x4,y4,z4,true);	
  glEnd;
  glEnable(GL_CULL_FACE);
  TwoSideOFF;  
end; 


procedure OpenGL_CreateList();

procedure OpenGL_Texture();
begin    

  TextureLoadID('Floor04.bmp',0);
  TextureLoadID('rock.bmp',1); 

  TextureLoadTGAID('jet5.tga',0);  
  
end;
begin 

  OpenGL_Texture();
  
  SetMultiTexture(2);  
  
  ActiveTextureON(GL_TEXTURE2); 
  TextureSelectID(2); 
  
  glMatrixMode(GL_TEXTURE);
  glScalef(1/3,1/3,0);
  glMatrixMode(GL_MODELVIEW);    
  
end;


procedure OpenGL_Draw();

procedure OpenGL_Draw2D();
begin
 
  OpenGL_I2D(0,0,0,0);       // inizializza la grafica 2D 
  
  OpenGL_Init(150,0,0,0,0);  // reimposta la grafica 3D
  
end;
procedure OpenGL_Mouse2D();
begin
  
end;
procedure OpenGL_Keyboard();
begin
  
end;
begin

  glClear(GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT);
  glLoadIdentity();
 
  OpenGL_Draw2D();               // carica gli elementi per la grafica 2d 
  OpenGL_Mouse2D();              // carica i comandi del mause per la grafica 2d
  OpenGL_Keyboard();             // carica i comandi della tastiera
  
  glTranslatef(0,-1,-30);        // regola l'inquadratura degli elementi nello schermo 
  glRotatef(35,1,0,0); 
  SetglMouseMove(GL_M0,2);   
  glRotatef(45,0,-1,0);     
  
  PutglPointLight(GL_LIGHT0,0, 0,10,0, 0.1);  
  
  AutoMultiTextureON;
  
  ActiveTextureON(GL_TEXTURE2);  
  TextureTGASelectID(0);  
  
  ActiveTextureON(GL_TEXTURE1);  
  TextureSelectID(0); 
  
  ActiveTextureON(GL_TEXTURE0); 
  TextureSelectID(1);
  
  Quad(-10,0,-10, 10,0,-10, -10,0,10, 10,0,10); 
  
  ActiveTextureOFF(GL_TEXTURE2);  
  
  ActiveTextureOFF(GL_TEXTURE1); 
  
  ActiveTextureOFF(GL_TEXTURE0);    
  
  AutoMultiTextureOFF;
  
  TextureSelectID(1); 
  glPushMatrix;
  glTranslatef(0,6,0);    
  glRotatef(90,1,0,0); 
  Sfera(0,0,0, 4,20,20, 1/3);
  glPopMatrix;  
  
end;

// inizio del programma
begin

 if MessageBox(0,'Settare lo schermo intero?  ', 'Video!',MB_YESNO OR MB_ICONQUESTION) = IDNO 
  then fullscreen := false else fullscreen := true;
  
 OGLWindowSetting(ARROW,'',GENERIC,'');
 CreateOGLWindow('Esempio di auto multi texture', 800, 600, 32, fullscreen);// si possono usare anche dei rapporti diversi da 4/3 o 16/9
 OpenGL_Init(150,0,0,0,0);			  // inizializza la grafica OpenGL(consente d'impostare il colore di sfondo e la profondit della visuale) 
 SetglRefractive();                         // imposta la rifrazione ambientale ed elimina le facce interne
 SetglLight(GL_LIGHT0,0.0,0.0,0.0,0.1);     // imposta la luce ambientale
 OpenGL_CreateList();                       // carica le liste degli oggetti (modelli composti)

 // impostare qui i valori delle variabili   

 REPEAT				     // inizio del ciclo principale

 glCLEAR(GL_COLOR_BUFFER_BIT);
 Setglmsg();

 OpenGL_Draw();             // carica gli elementi che devono essere un aggiornati sullo schermo 
 SwapBuffers(dcWindow);	    // abilita la visualizzazione grafica OpenGL

 // inserire qui eventuali dati aggiuntivi

UNTIL active = false;		// fine del ciclo principale (premere ESC per uscire)

 DeleteOGLWindow();		    // chiude la finestra
end.
